#include	<avr/io.h>
#include	<avr/interrupt.h>

// ͷƮ  ̺
#define	INT_IN		INT7_vect
#define	INT_OUT		INT6_vect
#define	INT_EMERGENCY	INT5_vect

// Է :   ġ ȣ ̺
#define	IN_SENSOR		PE7
#define	OUT_SENSOR		PE6
#define	EMERGENCY_SW 	PE5
#define	ONOFF_SW		PE4
#define	SW_ON			(!(PINE & 1<<ONOFF_SW))

//  : LED ȣ ̺
#define	LED			PE3
#define	LED_PORT		PORTE
#define	LED_DDR		DDRE
#define	LED_ON		(LED_PORT |= 1<<LED)
#define	LED_OFF		(LED_PORT &= ~(1<<LED))

//  :   ȣ ̺
#define	AC	PB7
#define	BD	PB6
#define	MOTOR_PORT	PORTB
#define	MOTOR_DDR	DDRB
#define	CLAER	(MOTOR_PORT & 0x3F)

//   ũ 
#define	MOTOR_FOREWARD	(MOTOR_PORT = (MOTOR_PORT & CLAER) | 1<<AC)
#define	MOTOR_BACKWARD	(MOTOR_PORT = (MOTOR_PORT & CLAER) | 1<<BD)
#define	MOTOR_STOP		(MOTOR_PORT = (MOTOR_PORT & CLAER) | 1<<AC | 1<<BD)

//  PWM ȣ ̺
#define	OC0	PB4

//  
#define	BLINK_INTERVAL		100UL
#define	SEVEN_SEG_INTERVAL	2UL
#define	DEBOUNCE_INTERVAL	50UL
#define	TIMEOUT_INTERVAL	2000UL

#define	DIGIT_TEN	PD7		// 7-׸Ʈ ÷ 10 ڸ ̺
#define	DIGIT_ONE	PD6		// 7-׸Ʈ ÷ 1 ڸ ̺

unsigned char led[] = {0x48, 0x7D, 0xC4, 0x64, 0x71, 0x62, 0x43, 0x7C, 0x40, 0x70};

volatile unsigned char in_req=0, out_req=0, emer_req=0;	// û 
volatile unsigned char  blink_req=0, debounce_req=0;	

volatile unsigned	long	timer0=0, debounce_timer=0;	// Ÿ̸ ÷  

// ۾  ǰ , ۾ ϷǾ  ǰ 
volatile int on_product=0, out_product=0;

ISR(INT_IN)		{	in_req = 0; 	}	// ǰ 
ISR(INT_OUT)		{	out_req = 0; 	}	// ǰ 
ISR(INT_EMERGENCY)	{	if(debounce_req==0) emer_req = 0; 	}	//  ġ 

ISR(ADC_vect)
{	OCR0 = ADC >> 2;	}	// 10Ʈ ADC  8Ʈ 


// Ÿ̸/ī0 ͷƮ  ƾ
ISR(TIMER0_OVF_vect)
{
	timer0++;		// ÷θ 1 
	
	// ÷ Ƚ 4   10ڸ, ׷  2   1ڸ ÷
	if(timer0 % SEVEN_SEG_INTERVAL == 0){	
		PORTC = (timer0%(2*SEVEN_SEG_INTERVAL) == 0) ? led[(out_product%100) / 10] : led[out_product%10];
		PORTD = (PORTD |0xC0) & ~(1<<((timer0 % (2*SEVEN_SEG_INTERVAL) == 0) ? DIGIT_TEN : DIGIT_ONE));
	}

	// blink_req̸ LED BLINK_INTERVAL 
	if(blink_req)
		if(timer0 % BLINK_INTERVAL == 0)
			LED_PORT ^= 1<<LED;		// LED  ݴ ٲ
	
	// debounce_req̸ DEBOUNCE_INTERVAL ð ġ  ν 
	if(debounce_req==1){
	    	debounce_req = 2;		 
    		debounce_timer = 0;		     // debounce_timer 0 ʱȭ
	}else if(debounce_req==2){
		debounce_timer++;
		if(debounce_timer >= DEBOUNCE_INTERVAL){
			debounce_timer = 0L;
			debounce_req = 0;
		}
	}
}

enum { OFF, READY, WORKING, OUT, EMERGENCY } state = OFF;	//    

int	main(void)
{	unsigned long imsi_timer=0;

	DDRA = 0xFF;				//  Ϳ LED
	DDRC = 0xFF;				// 7-׸Ʈ  Ʈ
	DDRD |= 1<<PD7 | 1<<PD6;		//   7-׸Ʈ LED ѱ  

	MOTOR_DDR |= 1<<AC | 1<<BD;		//   Ʈ AC, BD   

	LED_DDR |= 1<<LED;	           //  ȣ
	PORTE |= 1<<EMERGENCY_SW | 1<<ONOFF_SW;		// ġ Է Ǯ  

	EIMSK |= 1<<IN_SENSOR | 1<<OUT_SENSOR | 1<<EMERGENCY_SW;  // ܺ ͷƮ
	EICRB = 0b10111000;	// ͷƮ ߻ (INT7, INT6, INT5, INT4) : ϰ, , ϰ, 
	// OC0 PWM 
	DDRB |= 1<<OC0;		           // OC0  
	TCCR0 = 1<<WGM01 | 1<<WGM00;	//  PWM  ߻ 
	TCCR0 |= 1<<COM01 | 1<<COM00;	// TCNT0 0x0 1, ϰ  OCR0 ġϸ 0
	TCCR0 |= 1<<CS02 | 1<<CS00;	// 128  
	TIMSK |= 1<<TOIE0;			// Ÿ̸/ī0 ͷƮ Ȱȭ

	// ADC Ȱȭ, ADC ͷƮ Ȱȭ,  , AD , Ϸ CPU ֺ=64
	ADCSRA |= 1<<ADEN | 1<<ADIE | 1<<ADFR | 1<<ADSC | 6;
	sei();

	MOTOR_STOP;
	out_product = 0;
	while(1){
	  PORTA = 1<<state;				//    PA0 ~ PA4 LED Ͽ 
	  switch(state){
	  	case OFF:					// ó 
			LED_OFF;
			if(SW_ON){				//  ġ ON
				LED_ON;
				out_product = 0;
				in_req = out_req = emer_req = 1;
				state = READY;
			}
			break;
			
		case READY:
			if(in_req==0){			// ǰ 
				in_req = out_req = emer_req = 1;
				timer0 = 0UL;
				MOTOR_FOREWARD;
				on_product++;
				state = WORKING;
			}else if(!SW_ON)		//  ġ OFF
				state = OFF;
			break;

		case WORKING:
			if(in_req==0){			// ǰ 
				in_req = 1;
				timer0 = 0UL;
				on_product++;
			}else if(emer_req==0){	//  ġ 
				emer_req = blink_req = debounce_req = 1;
				MOTOR_STOP;
				imsi_timer = timer0;
				state = EMERGENCY;
			}else if(out_req==0){	// ǰ 
				out_req = 1;
				out_product++;
				on_product--;
				state = OUT;
			}else if(timer0 >= TIMEOUT_INTERVAL){  // ǰ ̾ ð 
				MOTOR_STOP;
				on_product = 0;
				state = READY;
			}else if(!SW_ON){		//  ġ OFF
				MOTOR_STOP;
				state = OFF;
			}	
			break;
			
		case OUT:
			if(on_product <= 0){		// ǰ ̾  
				MOTOR_STOP;
				on_product = 0;
				state = READY;
			}else					// ǰ  ̾  
				state = WORKING;
			break;

		case EMERGENCY:
			if(emer_req==0){		//  ġ ٽ 
				emer_req = debounce_req = 1;
				blink_req = 0;
				timer0 = imsi_timer;
				LED_ON;
				MOTOR_FOREWARD;
				state = WORKING;
			}else if(!SW_ON)		//  ġ OFF
				state = OFF;
			break;
		default: break;
	  }
	}
	
	return 0;
}
